/* Example: National Lottery numbers selector */
/* Version 2: Global array made local to main, and passed
as a function argument. Random number generator added. 
Selected numbers are now printed. */

#include <stdio.h>
#include <stdlib.h>

void choose_numbers(int selection[6]);
void print_numbers(int selection[6]);
int random_ball(int min, int max);


main()
{
  int selection[6];  /* array of six numbers selected */
  
  choose_numbers(selection);
  print_numbers(selection);
  return;
}


void choose_numbers(int selection[6])
{
  int i;
  
  for (i = 0; i < 6; i++)
    selection[i] = random_ball(1, 49);
  return;
}


void print_numbers(int selection[6])
{
  int i;
  
  for (i = 0; i < 6; i++)
    printf("%i ", selection[i]);
  putchar('\n');
  return;
}


int random_ball(int min, int max)
{
  double x;
  
  x = (double) rand(); /* returns integer from 0 to RAND_MAX */
  
  x /= ((double) RAND_MAX + 1);  /* a double from 0 to just less than 1 */
  /* Leaving out the cast gave overflow problems. Not sure why. */
  
  x = (max - min + 1) * x + min;
                       /* a double from min to just less than max + 1 */
  return (int) x;
}
